/*
 * All Rights Reserved.
 * Copyright (C) 1999-2005 Tsukuba Bunko.
 *
 * Licensed under the BSD License ("the License"); you may not use
 * this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.tsukuba-bunko.org/licenses/LICENSE.txt
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Id: BackgroundHandler.java,v 1.2 2005/08/17 17:40:29 ppoi Exp $
 */
package tsukuba_bunko.peko.scenario.stage;

import	org.xml.sax.Attributes;

import	tsukuba_bunko.peko.resource.ResourceManager;

import	tsukuba_bunko.peko.scenario.PSMLUtil;


/**
 * <samp>background</samp>  <code>ElementHandler</code> łB
 * @author	$Author: ppoi $
 * @version	$Revision: 1.2 $
 */
public class BackgroundHandler	extends StageElementHandler	{

	/**
	 * <code>BackgroundHandler</code> ̃CX^X쐬܂B
	 */
	public BackgroundHandler()
	{
		super();
	}


//
//	ContentHandler ̎
//
	public void startElement( String namespaceURI, String localName, String qName, Attributes attrs )
	{
		StageCoordinator	coordinator = getStageCoordinator();
		String	background = PSMLUtil.getAttributeValue( attrs, "image" );
		if( background != null )	{
			coordinator.setBackgroundImage( background );
		}
		else	{
			background = PSMLUtil.getAttributeValue( attrs, "color" );
			coordinator.setBackgroundColor( background );
		}

		String	effect = PSMLUtil.getAttributeValue( attrs, "effect" );
		if( effect == null )	{
			ResourceManager	resources = ResourceManager.getInstance();
			effect = (String)resources.getResource( ResourceIDs.DEFAULT_EFFECT_BACKGROUND, true );
		}
		if( !coordinator.isSlideVisible() )	{
			coordinator.updateStage( effect );
		}
	}
}
